#pragma comment(lib,"vfw32.lib")

#include <windows.h>
#include "resource.h" 
#include "vfw.h"

HWND hCapWnd=NULL;
HWND hWndCapture=NULL;

LRESULT PASCAL VideoStreamCallbackProc(HWND hWnd, LPVIDEOHDR lpVHdr)
{		
	HDC hDC  = GetDC(hWndCapture);	
	HDC hMemDC = CreateCompatibleDC(hDC);
	HBITMAP hBitmap;	
	BITMAPINFO BitmapInfo;
	
	capGetVideoFormat(hWnd, &BitmapInfo, sizeof(BITMAPINFO));

	hBitmap = CreateDIBitmap(hDC, &BitmapInfo.bmiHeader, CBM_INIT, lpVHdr->lpData, &BitmapInfo, DIB_RGB_COLORS);
	
	SelectObject(hMemDC, hBitmap);
	BitBlt(hDC, 0, 0, 320, 240, hMemDC, 0, 0, SRCCOPY);
	
	DeleteObject(SelectObject(hMemDC, hBitmap));
	DeleteDC(hMemDC);
	ReleaseDC(hWndCapture, hDC);
	
	return TRUE;
}

BOOL CALLBACK DlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	HWND hWndParent=NULL;	
	
	switch(Message)
	{		
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_CONNECT:				
					hWndParent = GetDlgItem(hwnd, IDC_STATIC1);					
					hCapWnd = capCreateCaptureWindow("My Test Capture Window",
                                                      WS_CHILD|WS_VISIBLE, 1, 1, 320, 240, hWndParent, TRUE);
					
					if (hCapWnd) {
						capDriverConnect(hCapWnd, 0);
						capSetCallbackOnVideoStream(hCapWnd, VideoStreamCallbackProc);
						capPreviewRate(hCapWnd, 10);
						capPreview(hCapWnd, TRUE);
					}				
					break;				
				case IDC_CAPTURE:
					if (hCapWnd) {						
						hWndCapture = GetDlgItem(hwnd, IDC_STATIC2);
						capCaptureSequenceNoFile(hCapWnd);
					}
					break;
				case IDC_STOP:				
					if (hCapWnd) {
						capCaptureStop(hCapWnd);
					}
					break;
			}
		    break;		
		case WM_CLOSE:
			if (hCapWnd) {
				capSetCallbackOnVideoStream(hCapWnd, NULL);
				capDriverDisconnect(hCapWnd);
			}
			EndDialog(hwnd, 0);		
		    break;		
		default:
			return FALSE;
	}
	return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{	
	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, DlgProc);
}
