#pragma comment(lib,"vfw32.lib")

#include <windows.h>
#include <math.h>
#include "resource.h" 
#include "vfw.h"

HWND hCapWnd=NULL;
HWND hWndCapture=NULL;

HDC hDC;	
HDC hMemDC;
HBITMAP hBitmap;	
BITMAPINFO BitmapInfo;

void CreateBmpHeader()
{
	hDC  = GetDC(hWndCapture);	
    hMemDC = CreateCompatibleDC(hDC);
		
	BitmapInfo.bmiHeader.biPlanes      = 1;
	BitmapInfo.bmiHeader.biBitCount    = 24;
	BitmapInfo.bmiHeader.biHeight      = 240;
	BitmapInfo.bmiHeader.biWidth       = 320;	
	BitmapInfo.bmiHeader.biCompression = 0;
	BitmapInfo.bmiHeader.biSize        = sizeof(BitmapInfo.bmiHeader);
}

void RGB2BIN(BYTE *src)
{
	int  i, j, count=0;
	BYTE r=0,g=0,b=0,Gray=0;
	BYTE data[320*240*3];

	for( i=1; i<=320; i++ )   
	{
		for( j=1; j<=240; j++ )
		{	
			r = src[count+2];
			g = src[count+1];
			b = src[count];
			Gray   = (BYTE) (sqrt(((r*r) + (g*g) + (b*b)) / 3));
			
			if (Gray > 100) {
				data[count+2] = 255;
				data[count+1] = 255;
				data[count] = 255;
			} else {
				data[count+2] = 0;
				data[count+1] = 0;
				data[count] = 0;
			}			
			count = count + 3;				
		}
	}
	hBitmap = CreateDIBitmap(hDC, &BitmapInfo.bmiHeader, CBM_INIT, data, &BitmapInfo, DIB_RGB_COLORS);
			
	SelectObject(hMemDC, hBitmap);
	BitBlt(hDC, 0, 0, 320, 240, hMemDC, 0, 0, SRCCOPY);		
}

LRESULT PASCAL VideoStreamCallbackProc(HWND hWnd, LPVIDEOHDR lpVHdr)
{
	RGB2BIN(lpVHdr->lpData);	
	return TRUE;
}

BOOL CALLBACK DlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	HWND hWndParent=NULL;	
	
	switch(Message)
	{		
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_CONNECT:				
					hWndParent = GetDlgItem(hwnd, IDC_STATIC1);					
					hCapWnd = capCreateCaptureWindow("My Test Capture Window",
                                                      WS_CHILD|WS_VISIBLE, 1, 1, 320, 240, hWndParent, TRUE);
					
					if (hCapWnd) {
						capDriverConnect(hCapWnd, 0);
						capSetCallbackOnVideoStream(hCapWnd, VideoStreamCallbackProc);
						capPreviewRate(hCapWnd, 100);
						capPreview(hCapWnd, TRUE);						
					}				
					break;				
				case IDC_FILTER:
					if (hCapWnd) {
						hWndCapture = GetDlgItem(hwnd, IDC_STATIC2);
						CreateBmpHeader();
						capCaptureSequenceNoFile(hCapWnd);

					}
					break;
				case IDC_STOP:				
					if (hCapWnd) {
						capCaptureStop(hCapWnd);
						DeleteObject(SelectObject(hMemDC, hBitmap));
						DeleteDC(hMemDC);
						ReleaseDC(hWndCapture, hDC);
					}
					break;
			}
		    break;		
		case WM_CLOSE:
			if (hCapWnd) {
				capCaptureStop(hCapWnd);
				capSetCallbackOnVideoStream(hCapWnd, NULL);
				capDriverDisconnect(hCapWnd);
			}
			EndDialog(hwnd, 0);		
		    break;		
		default:
			return FALSE;
	}
	return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{	
	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, DlgProc);
}
